質問をすることでしか得られない、回答やアドバイスがある。

15分調べてもわからないことは、質問しよう!

ただいまの
回答率

89.97%

結局RubyInstallerは何をしてくれるのか

解決済

回答 2

投稿 編集

  • 評価
  • クリップ 0
  • VIEW 435

yumetodo

score 3865

Windows環境でRubyをInstallするにはRubyInstallerを使うのが一般的のようです。
https://github.com/oneclick/rubyinstaller2

説明書きには

MSYS2 based RubyInstaller for Windows

とあります。

ridkコマンドの説明を見てもRubyのバージョン切り替え機能がある以外はmsys2に投げているように見えます。

ではRubyのバージョン切り替えを考えないとき、RubyInstallerは必要なのでしょうか?msys2のpacmanでもrubyは落とせます。これとの違いはなにかあるのでしょうか?

例えばmsys2 pacmanで入れたrubyではどうしても何かが実現できなくてRubyInstallerで入れたRubyでないと実装できないようなgemがありえたりするのでしょうか?

例えばmsys2のビルド方法となにか違う方法でビルドしているのでしょうか?msys2では
https://github.com/msys2/MINGW-packages/blob/master/mingw-w64-ruby/PKGBUILD
にあるようにごく普通にconofigureしてmakeしています。


きっかけとしてはruby2dというgemをmsys2 pacmanで入れたRubyでrequireできないという問題があり、ruby2d公式チャットで問い合わせたところ

https://github.com/ruby2d/ruby2d/blob/43ce9805a7ae8b82b7ab8c50bf6d4c845d395dc4/lib/ruby2d.rb#L23

RubyInstaller決め打ちをしていることがわかり、そういう決め打ちはするべきではないのではないかといったところ

Ruby2D has RubyInstaller that's the issue I think
Your system doesn't have the module for whatever reason...

と明瞭な答えを得られなかったので、スコープを広げてRubyのgem制作一般でRubyInstallerでないといけないなにか不都合があるのかな?と思ったわけです。

  • 気になる質問をクリップする

    クリップした質問は、後からいつでもマイページで確認できます。

    またクリップした質問に回答があった際、通知やメールを受け取ることができます。

    クリップを取り消します

  • 良い質問の評価を上げる

    以下のような質問は評価を上げましょう

    • 質問内容が明確
    • 自分も答えを知りたい
    • 質問者以外のユーザにも役立つ

    評価が高い質問は、TOPページの「注目」タブのフィードに表示されやすくなります。

    質問の評価を上げたことを取り消します

  • 評価を下げられる数の上限に達しました

    評価を下げることができません

    • 1日5回まで評価を下げられます
    • 1日に1ユーザに対して2回まで評価を下げられます

    質問の評価を下げる

    teratailでは下記のような質問を「具体的に困っていることがない質問」、「サイトポリシーに違反する質問」と定義し、推奨していません。

    • プログラミングに関係のない質問
    • やってほしいことだけを記載した丸投げの質問
    • 問題・課題が含まれていない質問
    • 意図的に内容が抹消された質問
    • 広告と受け取られるような投稿

    評価が下がると、TOPページの「アクティブ」「注目」タブのフィードに表示されにくくなります。

    質問の評価を下げたことを取り消します

    この機能は開放されていません

    評価を下げる条件を満たしてません

    評価を下げる理由を選択してください

    詳細な説明はこちら

    上記に当てはまらず、質問内容が明確になっていない質問には「情報の追加・修正依頼」機能からコメントをしてください。

    質問の評価を下げる機能の利用条件

    この機能を利用するためには、以下の事項を行う必要があります。

回答 2

checkベストアンサー

0

何をやっているか

Windows(非msys2)環境でRubyを動かしつつ、一部gemのビルド時にはmsys2環境を呼び出すための色々ですね
おまけで、sqlite3, glut, fxruby, openssl, mysql2あたりのgemをビルドする際に
pacman操作なしに依存パッケージをインストールするための仕組みなども導入しています。

当該コードの是非

msys2 rubyをサポート外にするのはライブラリ開発者の自由かと思います。

当該コードについては

if defined?(RubyInstaller)
  s2d_dll_path = Gem::Specification.find_by_name('ruby2d').gem_dir + '/assets/mingw/bin'
  RubyInstaller::Runtime.add_dll_directory(File.expand_path(s2d_dll_path))
end

の方が少しはマシかと思います。

投稿

編集

  • 回答の評価を上げる

    以下のような回答は評価を上げましょう

    • 正しい回答
    • わかりやすい回答
    • ためになる回答

    評価が高い回答ほどページの上位に表示されます。

  • 回答の評価を下げる

    下記のような回答は推奨されていません。

    • 間違っている回答
    • 質問の回答になっていない投稿
    • スパムや攻撃的な表現を用いた投稿

    評価を下げる際はその理由を明確に伝え、適切な回答に修正してもらいましょう。

  • 2019/07/28 13:18

    ありがとうございます。
    問題のコードについては、ruby2dの開発者がどう反応するかはわかりませんがとりあえずasmさんの改善案そのままをPRにしてみました(著作権の許諾を取り忘れていました、問題があればPRを取り下げます。)
    https://github.com/ruby2d/ruby2d/pull/166

    キャンセル

0

環境ごとに動作確認を行う手間を考えれば、対象を利用者が多い一般的な環境に絞ることに不思議はない。

投稿

  • 回答の評価を上げる

    以下のような回答は評価を上げましょう

    • 正しい回答
    • わかりやすい回答
    • ためになる回答

    評価が高い回答ほどページの上位に表示されます。

  • 回答の評価を下げる

    下記のような回答は推奨されていません。

    • 間違っている回答
    • 質問の回答になっていない投稿
    • スパムや攻撃的な表現を用いた投稿

    評価を下げる際はその理由を明確に伝え、適切な回答に修正してもらいましょう。

15分調べてもわからないことは、teratailで質問しよう!

  • ただいまの回答率 89.97%
  • 質問をまとめることで、思考を整理して素早く解決
  • テンプレート機能で、簡単に質問をまとめられる